@ECHO OFF && PUSHD "%~dp0" && SETLOCAL EnableDelayedExpansion

:: Wrye Bash Debug.bat
::
:: Retrieves the Python executable path from the registry and runs Wrye Bash
:: with debugging turned on, redirecting all output to a log file.


:: initialize variables
SET OUTFILE=BashBugDump_startup.log
SET PYPATH=


:: adapt to the output format of reg on the current OS in the current locale
:: use a known present key that has a known value for the format autodetection
SET REGCMD=reg query HKLM\SOFTWARE\Classes\.exe /ve >NUL
SET SKIPVAL=0
FOR /F "usebackq tokens=*" %%i in (`%REGCMD%`) do (
    SET LINE=%%i
    SET TESTSTR=!LINE:exefile=!
    IF NOT x"!TESTSTR!"==x"!LINE!" GOTO TOKENTEST
    SET /A SKIPVAL=SKIPVAL+1)

:TOKENTEST
SET TOKENS=2
FOR /F "skip=%SKIPVAL% usebackq tokens=%TOKENS%*" %%i in (`%REGCMD%`) do IF x"%%j"==x"exefile" GOTO TOKENTESTDONE
SET TOKENS=3
FOR /F "skip=%SKIPVAL% usebackq tokens=%TOKENS%*" %%i in (`%REGCMD%`) do IF x"%%j"==x"exefile" GOTO TOKENTESTDONE
SET TOKENS=4
FOR /F "skip=%SKIPVAL% usebackq tokens=%TOKENS%*" %%i in (`%REGCMD%`) do IF x"%%j"==x"exefile" GOTO TOKENTESTDONE
SET TOKENS=5
FOR /F "skip=%SKIPVAL% usebackq tokens=%TOKENS%*" %%i in (`%REGCMD%`) do IF x"%%j"==x"exefile" GOTO TOKENTESTDONE
:TOKENTESTDONE


:: get python path from registry
SET REGCMD=reg query HKLM\SOFTWARE\Wow6432Node\Python\PythonCore\2.7\InstallPath /ve
%REGCMD% >NUL 2>&1 && FOR /F "skip=%SKIPVAL% usebackq tokens=%TOKENS%*" %%i in (`%REGCMD%`) do SET PYPATH=%%j
IF NOT x"%PYPATH%"==x"" GOTO FOUND

SET REGCMD=reg query HKLM\SOFTWARE\Python\PythonCore\2.7\InstallPath /ve
%REGCMD% >NUL 2>&1 && FOR /F "skip=%SKIPVAL% usebackq tokens=%TOKENS%*" %%i in (`%REGCMD%`) do SET PYPATH=%%j
IF NOT x"%PYPATH%"==x"" GOTO FOUND

SET REGCMD=reg query HKCU\SOFTWARE\Wow6432Node\Python\PythonCore\2.7\InstallPath /ve
%REGCMD% >NUL 2>&1 && FOR /F "skip=%SKIPVAL% usebackq tokens=%TOKENS%*" %%i in (`%REGCMD%`) do SET PYPATH=%%j
IF NOT x"%PYPATH%"==x"" GOTO FOUND

SET REGCMD=reg query HKCU\SOFTWARE\Python\PythonCore\2.7\InstallPath /ve
%REGCMD% >NUL 2>&1 && FOR /F "skip=%SKIPVAL% usebackq tokens=%TOKENS%*" %%i in (`%REGCMD%`) do SET PYPATH=%%j
IF NOT x"%PYPATH%"==x"" GOTO FOUND


:: if all that failed, try querying the .py file association
SET REGCMD=reg query HKCR\Python.File\shell\open\command /ve
%REGCMD% >NUL 2>&1 || GOTO NOTFOUND
FOR /F "skip=%SKIPVAL% usebackq tokens=%TOKENS%*" %%i in (`%REGCMD%`) do SET PYASSOC=%%j
SET PYASSOC=!PYASSOC:"=?!
FOR /F "tokens=1 delims=?" %%i in ("%PYASSOC%") do SET PYTHON=%%i
IF NOT x"%PYTHON%"==x"" GOTO FOUNDPYTHON


:NOTFOUND
ECHO Python not found >%OUTFILE%
ECHO Python not found
GOTO END


:FOUND
SET PYTHON=%PYPATH%pythonw.exe

:FOUNDPYTHON
ECHO Found Python at '%PYTHON%'
ECHO Found Python at '%PYTHON%' >%OUTFILE%
ECHO Launching Wrye Bash 307 in debug mode
ECHO Launching Wrye Bash 307 in debug mode >>%OUTFILE%
:: Line below won't do due to us redirecting stdout/err inside bash.py
SET PYTHONIOENCODING=UTF8
:: The following line checks if %OUTFILE% is writeable to determine if there is
:: a second instance of wrye bash already running
2>nul (
   >>%OUTFILE% (call )
) && (("%PYTHON%" "Wrye Bash Launcher.pyw" -d %1 %2 %3 %4 %5 %6 %7 %8 %9 >>%OUTFILE% 2>&1) || echo.) || (echo Cannot launch Wrye Bash because another instance is already running) && PAUSE

:END
ENDLOCAL && EXIT /B
